uniform float timer;

vec4 Process(vec4 color)
{
    vec2 texCoord = gl_TexCoord[0].st;

    const float pi = 3.14159265358979323846;

    vec2 gridTexCoord = floor(texCoord * 64.0) / 64.0;

    float siny = floor(pi * (gridTexCoord.y + floor(timer)));
    float sinx = floor(pi * (gridTexCoord.x + floor(timer)));

    vec2 offset = vec2(
        sinx + floor(pi * (gridTexCoord.x * 8.0 + sin(timer / 2.0) + timer / 8.0)) / 64.0,
        siny + floor(pi * (gridTexCoord.y * 8.0 + sin(timer / 2.0) + timer / 8.0)) / 64.0
    );

    vec2 offset2 = vec2(
        sinx - floor(pi * (gridTexCoord.x * 8.0 + sin(timer / 2.0) + timer / 8.0)) / 64.0,
        siny - floor(pi * (gridTexCoord.y * 8.0 + sin(timer / 2.0) + timer / 8.0)) / 64.0
    );

    vec2 texCoordOffset = texCoord - gridTexCoord;
    vec2 texCoordWithOffset = gridTexCoord + offset + texCoordOffset;
    vec2 texCoord2WithOffset = gridTexCoord - offset + texCoordOffset;
    vec2 texCoord3WithOffset = gridTexCoord + offset2 + texCoordOffset;
    vec2 texCoord4WithOffset = gridTexCoord - offset2 + texCoordOffset;

    return (
        getTexel(texCoordWithOffset) / 4.0 +
        getTexel(texCoord2WithOffset) / 4.0 +
        getTexel(texCoord3WithOffset) / 4.0 +
        getTexel(texCoord4WithOffset) / 4.0
    ) * color;
}

